
<template>
  <el-dialog
    width="50%"
    title="Choose location of job"
    :visible="dialogvisible"
    append-to-body
    :close-on-click-modal="false"
    @close="$emit('update:dialogvisible', false)"
  >
    <div class="page-gmaps scrollable">
      <div class="card-base card-shadow--medium">
        <gmap-autocomplete
          :value="description"
          @place_changed="setPlace"
          class="input-item"
          :selectFirstOnEnter="true"
        >
        </gmap-autocomplete>
        <gmap-map
          @click="onMapClick"
          id="map"
          :center="center"
          :zoom="zoom"
          style="width: 100%; height: 300px"
        >
          <gmap-marker
            v-if="zoom != 2"
            :position="center"
            :clickable="false"
            :draggable="false"
          ></gmap-marker>

        </gmap-map>

      </div>
      <div style="text-align: right; margin-top: 40px">
        <el-button
          type="primary"
          @click="save"
        >Save</el-button>
      </div>
    </div>
  </el-dialog>

</template>

<script>
// var google = window.google;
// import * as VueGoogleMaps from 'vue2-google-maps'
export default {
  name: 'MapPicker',
  props: [
    'dialogvisible',
    "latitude",
    "longitude",
    "address",
    "detail",
    "postal_code"
  ],
  data () {
    return {
      center: { lat: 34, lng: -118 },
      markers: [
        { position: { lat: 47.3700, lng: 8.5310 } }
      ],
      getMap: this.$root.mapping,
      description: '',
      latLng: {},
      place: null,
      coordinates: null,
      location: {},
      zoom: 2,
    }
  },
  mounted () {

  },
  methods: {


    setDescription (description) {
      // console.log('description :', description);
      this.description = description
    },
    setPlace (place) {
      /*eslint-disable-next-line*/
      console.log('place', place);
      if (!place.address_components) {
        return;
      }
      else {
        this.zoom = 18;

        let district, city, country;


        place.address_components.map(e => {
          /*eslint-disable-next-line*/
          //   console.log("e.type:", e.types);
          switch (e.types[0]) {
            case 'administrative_area_level_2':
              district = e.long_name
              break
            case 'administrative_area_level_1':
              city = e.long_name
              break
            case 'country':
              country = e.long_name
              break
          }
        })
        let data = {
          street: place.formatted_address,
          district: district,
          city: city,
          country: country,
          postal_code: this.postal_code,
          latitude: place.geometry.location.lat(),
          longitude: place.geometry.location.lng(),
        }
        // console.log('data Adress  :', data);
        this.location = data;
        this.latLng = {
          lat: place.geometry.location.lat(),
          lng: place.geometry.location.lng(),
        }
        this.description = place.formatted_address;
        this.$emit('update:detail.address', place.formatted_address)
        this.center = this.latLng;
      }
    },
    geocodeLatLng (geocoder, map, infowindow) {
      geocoder.geocode({ 'location': this.center }, function (results, status) {
        /*eslint-disable*/
        // console.log(results, status);
      });
    },
    onMapClick (object) {
      /*eslint-disable*/
      // console.log('object :', object);
      // if(!object || !object.qa) return;
      // this.center.lat = object.qa.x;
      // this.center.lng = object.qa.y;
    },
    initPosision () {
      this.center = {
        lat: this.latitude,
        lng: this.longitude
      }
      this.description = this.address;
    },
    save () {

      console.log('this.address :', this.address);
      console.log('this.location :', this.location);
      console.log('this.description :', this.description);
      this.$emit('update:dialogvisible', false);
      this.$emit('update:location', this.location);
      this.$emit('update:address', this.description)
      this.$emit('update:latitude', this.center.lat);
      this.$emit('update:longitude', this.center.lng);
    }


  },
  watch: {
    latitude: function () {
      if (this.latitude && this.longitude) {
        this.zoom = 18
        this.initPosision();
      }

    },
    dialogvisible: function () {
      if (this.latitude && this.longitude) {
        this.initPosision();
      }

    }
  },
}
</script>

<style lang="scss" scoped>
@import "../../../assets/scss/_variables";

.input-item {
  -webkit-appearance: none;
  background-color: #fff;
  background-image: none;
  border-radius: 4px;
  border: 1px solid #dcdfe6;
  -webkit-box-sizing: border-box;
  box-sizing: border-box;
  color: #606266;
  display: inline-block;
  font-size: inherit;
  height: 40px;
  line-height: 40px;
  outline: none;
  padding: 0 15px;
  -webkit-transition: border-color 0.2s cubic-bezier(0.645, 0.045, 0.355, 1);
  transition: border-color 0.2s cubic-bezier(0.645, 0.045, 0.355, 1);
  width: 100%;
}

.page-gmaps {
  .map-app {
    max-height: 500px;
  }
}

@media (max-width: 768px) {
  .page-gmaps {
    .map-app {
      max-height: inherit !important;
      display: block;

      .settings-panel,
      .map-panel {
        display: block;
        overflow: hidden;
        width: 100%;
        max-width: 100%;
        height: 400px;
      }
      .settings-panel {
        overflow: auto;
      }
    }
  }
}
</style>
<style lang="scss">
.page-gmaps {
  .map-app {
    .settings-panel {
      [type="text"] {
        background-color: rgba(255, 255, 255, 0.2);
        border: 1px solid rgba(255, 255, 255, 0.3);
      }
    }
  }
}
.gm-style .gm-style-iw {
  color: black;
}
</style>


